/* c-basic-offset: 2; tab-width: 2; indent-tabs-mode: nil
 * vi: set shiftwidth=2 tabstop=2 expandtab:
 * :indentSize=2:tabSize=2:noTabs=true:
 */
 
 /*
  * The GPumpAuth class authenticates the user with a Pump.io node.
  * 
  * GPump contains a widget that needs to be associated with a top-level window,
  * or dialoug window associated a top level window.
  *
  * The special widget is a dialoug box with a WebKitWebView that displays the
  * authentication page.
  * 
  * The keys are stored in the object untill they are gotten after which the
  * keys are freed and zeroed. After that point, the keys are not avalible for
  * this class.
  */

#include <gtk/gtk.h>
#include <gio/gio.h>
#include <rest/oauth2-proxy.h>
#include <rest/rest-proxy-call.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n.h>

#define GPUMP_TYPE_AUTH             (gpump_auth_get_type ())
#define GPUMP_AUTH(obj)             (G_TYPE_CHECK_INSTANCE_CAST((obj), GPUMP_TYPE_AUTH, GPumpAuth))
#define GPUMP_AUTH_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST((klass), GPUMP_TYPE_AUTH, GPumpAUTHClass))
#define GPUMP_IS_AUTH(obj)           (G_TYPE_CHECK_INSTANCE_TYPE((obj), GPUMP_TYPE_AUTH))
#define GPUMP_IS_AUTH_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), GPUMP_TYPE_AUTH))
#define GPUMP_AUTH_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS((obj), GPUMP_TYPE_AUTH, GPumpAuthClass))

/*
 * NAMESPACE: gpump_*
 * 
 * The authenication widget that is use for authentication of the user with a
 * Pump.io node.
 * 
 * The parent is a GtkDialog and uses GtkWebkit.
 * 
 * CLASS NAMESPACE: gpump_auth_*
 */


typedef struct GPumpAuth GPumpAuth;
typedef struct GPumpAuthPrivate GPumpAuthPrivate;
typedef struct GPumpAuthClass GPumpAuthClass;

/**
 * GPumpAuth is a widget is used for getting the OAuth information from the
 * Pump.io node.
 */
struct GPumpAuth {
  GtkDialog parent;
  
};

struct GPumpAuthClass {
  GtkDialogClass parent_class;
};

GType gpump_auth_get_type (void) G_GNUC_CONST;

/**
 * 
 */
GPumpAuth * gpump_auth_new (void);

