/* c-basic-offset: 2; tab-width: 2; indent-tabs-mode: nil
 * vi: set shiftwidth=2 tabstop=2 expandtab:
 * :indentSize=2:tabSize=2:noTabs=true:
 */

#include "GPumpSettings.h"
#include "GPumpSettingsData.h"

struct GPumpSettingsPrivate {
  GtkWidget * layout;
  
};

#define GPUMP_SETTINGS_GET_PRIVATE(obj)\
  (G_TYPE_INSTANCE_GET_PRIVATE ((obj), GPUMP_TYPE_SETTINGS,\
   GPumpSettingsPrivate))

G_DEFINE_TYPE (GPumpSettings, gpump_settings, GTK_TYPE_DIALOG)

/* * Callback function definitions ********************************************/
void _cb_on_response (GtkWidget * widget, gint response_id, gpointer user_data);


GPumpSettings * gpump_settings_new (GtkWidget * parent) {
  GPumpSettings * self = g_object_new (GPUMP_TYPE_SETTINGS,
                         "title", _("GPump settings"),
                         "transient-for", parent,
                         "attached-to", parent,
                         NULL, NULL);
  return self;
}

void gpump_settings_init (GPumpSettings * self) {
  self->priv = GPUMP_SETTINGS_GET_PRIVATE (self);
  gtk_dialog_add_buttons (GTK_DIALOG (self), _("Okay"), GTK_RESPONSE_OK, NULL, NULL);
  
  g_signal_connect (G_OBJECT (self), "response", G_CALLBACK (_cb_on_response),
                    self);
  
  gtk_window_set_default_size (GTK_WINDOW(self), 500,500);
}

void gpump_settings_class_init (GPumpSettingsClass * klass) {
  g_type_class_add_private (klass, sizeof(GPumpSettingsPrivate));
}

void gpump_settings_show (GPumpSettings * self) {
  gtk_dialog_run (GTK_DIALOG(self));
}


/* * Callback function implementations ***************************************/
void _cb_on_response (GtkWidget * widget, gint response_id,
                      gpointer user_data) {
  GPumpSettings * self = GPUMP_SETTINGS (user_data);
  
  switch (response_id) {
    case GTK_RESPONSE_OK:
      gtk_widget_destroy (GTK_WIDGET (self));
      break;
    default:
      g_error ("Response \"%i\" is not handled in GPumpSettings...\n",
                response_id);
  }
  
}

