/* c-basic-offset: 2; tab-width: 2; indent-tabs-mode: nil
 * vi: set shiftwidth=2 tabstop=2 expandtab:
 * :indentSize=2:tabSize=2:noTabs=true:
 */

#ifndef __H_GPUMP_SETTINGS__
#define __H_GPUMP_SETTINGS__

#include <gtk/gtk.h>
#include <gio/gio.h>
#include <rest/oauth2-proxy.h>
#include <rest/rest-proxy-call.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n.h>


#define GPUMP_TYPE_SETTINGS              (gpump_settings_get_type ())
#define GPUMP_SETTINGS(obj)              (G_TYPE_CHECK_INSTANCE_CAST((obj), GPUMP_TYPE_SETTINGS, GPumpSettings))
#define GPUMP_SETTINGS_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST((klass), GPUMP_TYPE_SETTINGS, GPumpSettingsClass))
#define GPUMP_IS_SETTINGS(obj)           (G_TYPE_CHECK_INSTANCE_TYPE((obj), GPUMP_TYPE_SETTINGS))
#define GPUMP_IS_SETTINGS_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), GPUMP_TYPE_SETTINGS))
#define GPUMP_SETTINGS_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS((obj), GPUMP_TYPE_SETTINGS, GPumpSettingsClass))

typedef struct GPumpSettings GPumpSettings;
typedef struct GPumpSettingsClass GPumpSettingsClass;
typedef struct GPumpSettingsPrivate GPumpSettingsPrivate;

/*
 * NAMESPACE: gpump_*
 *
 * GPumpSettings
 *
 * GPumpSettings the widget tha displays the UI for the sittings dialoug.
 *
 * CLASS NAMESPACE: gpmup_settings_*
 */


/**
 * GPumpSettings is a widget that is used for changing the settings of GPump.
 * 
 * The data is stored in the singeltonian class GPumpSettingsData.
 */
struct GPumpSettings {
  GtkDialog parent;
  
  /* 
   * Priavte structure defined in the .c file.
   */
  GPumpSettingsPrivate * priv;
};

struct GPumpSettingsClass {
  GtkDialogClass parent;
};

/**
 * Create a settings widget and class that contains the settings of the
 * application. Do not free this untill the app is closing!
 * 
 * @param parent The parent widget, the widget that this widget is suppose to
 * be attatched to.
 */
GPumpSettings * gpump_settings_new (GtkWidget * parent);

/**
 * Shows the widget and attatches it to the parent window defined when the
 * object was created with gpump_setting_new.
 */
void gpump_settings_show (GPumpSettings * self);

/**
 * Hides the widget, this is only useful from the widget itself.
 * 
 */
void gpump_settings_hide (GPumpSettings * self);


#endif /* __H_GPUMP_SETTINGS__ */
